package jp.sourceforge.sos.cytoq;

import jp.sourceforge.sos.cytoq.analysis.ControlAnalysis;
import jp.sourceforge.sos.cytoq.analysis.algorithm.ControlAlgorithm;
import jp.sourceforge.sos.cytoq.analysis.imageColor.ControlImageColor;
import jp.sourceforge.sos.cytoq.analysis.process.ControlProcess;
import jp.sourceforge.sos.cytoq.color.ControlColor;
import jp.sourceforge.sos.cytoq.equation.ControlEquation;
import jp.sourceforge.sos.cytoq.main.ControlMain;

public class Builder {

	public Builder() {
		ControlMain control = new ControlMain();

		ControlColor controlColor = new ControlColor(control);
		ControlAnalysis controlAnalysis = new ControlAnalysis(controlColor);
		new ControlProcess(controlAnalysis);
		new ControlAlgorithm(controlAnalysis);
		ControlImageColor controlImageColor = new ControlImageColor(controlAnalysis);
		
		ControlEquation controlEquation = new ControlEquation(control);

		controlColor.init();
		controlEquation.init();

		controlAnalysis.init();
		control.init();
		controlImageColor.init();
	}

	/**
	 * @param args
	 *            the command line arguments
	 */
	public static void main(String args[]) {
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				new Builder();
			}
		});
	}

}
